#!/usr/bin/python

# Framework zur Aufgabe, einen Text optimal auf eine Anzahl Zeilen
# zu verteilen, so dass die Anzahl der Spaces insgesamt minimiert wird.
# Diese Aufgabe soll mit dynamischer Programmierung geloest werden.
#
# GZ, 2011


import sys

# check command line argumtns
if  len(sys.argv) < 3:
    print "Error: Wrong argument list"
    print "Usage: optimal_word_print.py textfile max-chars-per-line"
    sys.exit(2)

# maximum allowed number of characters per line
M = int(sys.argv[2])

# read text from file and convert into array of words
file = open( sys.argv[1] )
text = file.readline()
words = text.split();

# create array containing length of each word, i.e.,
# word_len[i] is the length word words[i]
word_len = [ len(w) for w in words]

# Hier kommt Ihr Code ;-)
# Ihr Code soll ein Array 'lines' erzeugen,
# das in jedem Element lines[l] ein Tupel (i,j) enthaelt;
# die Bedeutung davon ist, dass in Zeile l die Woerter i bis j (einschliesslich) stehen sollen.

# this is just a dummy 'lines' array so that this framework runs through as-is
lines = [ (0,9), (10,19), (20,len(words)-1) ]


# print final text with optimized line breaks
for i in range( len(lines) ):
    for j in range( lines[i][0], lines[i][1]+1 ):
        print words[j],                                    # trailing comma suppresses linebreak
    print "\n",                                            # now, the line is complete


pass # this is only necessary for M$ Visual Studio 

